diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureBoneshaleTree.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureBoneshaleTree.java
new file mode 100644
index 000000000..95b96c0a3
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureBoneshaleTree.java
@@ -0,0 +1,431 @@
+package net.minecraft.core.world.generate.feature.tree;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
+import net.minecraft.core.world.generate.feature.WorldFeature;
+
+import java.util.Random;
+
+public class WorldFeatureBoneshaleTree extends WorldFeature
+{
+	protected int leavesID;
+	protected int logID;
+
+    static final byte[] axisConversionArray = { 2, 0, 0, 1, 2, 1 };
+    Random rnd;
+    World world;
+    int[] origin = { 0, 0, 0 };
+    int height;
+    int trunkHeight;
+    double trunkHeightScale;
+    double branchDensity;
+    double branchSlope;
+    double widthScale;
+    double foliageDensity;
+    int trunkWidth;
+    int heightVariance;
+    int foliageHeight;
+    int[][] foliageCoords;
+    int heightMod;
+
+    @MethodParametersAnnotation(names = {"leavesID", "logID"})
+    public WorldFeatureBoneshaleTree(int leavesID, int logID)
+    {
+        this(leavesID, logID, 0);
+    }
+
+    @MethodParametersAnnotation(names = {"leavesID", "logID", "heightMod"})
+    public WorldFeatureBoneshaleTree(int leavesID, int logID, int heightMod)
+    {
+        rnd = new Random();
+        height = 0;
+        trunkHeightScale = 0.6D;
+        branchDensity = 1.0D;
+        branchSlope = 0.4D;
+        widthScale = 1.0D;
+        foliageDensity = 1.0D;
+        trunkWidth = 1;
+        heightVariance = 12;
+        foliageHeight = 4;
+        this.leavesID = leavesID;
+        this.logID = logID;
+        this.heightMod = heightMod;
+    }
+
+    void prepare()
+    {
+        trunkHeight = (int)((double) height * trunkHeightScale);
+        if (trunkHeight >= height)
+        {
+            trunkHeight = height - 1;
+        }
+        int numOfClustersPerY = (int)(1.4D + Math.pow((foliageDensity * (double) height) / 13D, 2D));
+        if (numOfClustersPerY < 1)
+        {
+            numOfClustersPerY = 1;
+        }
+        int[][] foliageCoords = new int[numOfClustersPerY * height][4];
+        int yEnd = (origin[1] + height) - foliageHeight;
+        int foliageCoordsIndex = 1;
+        int topY = origin[1] + trunkHeight;
+        int y = yEnd - origin[1];
+        foliageCoords[0][0] = origin[0];
+        foliageCoords[0][1] = yEnd;
+        foliageCoords[0][2] = origin[2];
+        foliageCoords[0][3] = topY;
+        yEnd--;
+        while (y >= 0) {
+            float shapeFac = shapeFunc(y);
+            if (shapeFac < 0.0F) {
+                yEnd--;
+                y--;
+            } else {
+                double offset = 0.5D;
+                for (int i = 0; i < numOfClustersPerY; i++) {
+                    double r = widthScale * ((double)shapeFac * ((double) rnd.nextFloat() + 0.328D));
+                    double theta = (double) rnd.nextFloat() * 2D * Math.PI;
+                    int x = MathHelper.floor(r * Math.sin(theta) + (double) origin[0] + offset);
+                    int z = MathHelper.floor(r * Math.cos(theta) + (double) origin[2] + offset);
+                    int[] branchEnd = { x, yEnd, z };
+                    int[] branchTopOfTree = { x, yEnd + foliageHeight, z };
+                    if (distToMat(branchEnd, branchTopOfTree) != -1) {
+                        continue;
+                    }
+                    int[] branchStart = { origin[0], origin[1], origin[2] };
+                    double dist = Math.sqrt(Math.pow(Math.abs(origin[0] - branchEnd[0]), 2D) + Math.pow(Math.abs(origin[2] - branchEnd[2]), 2D));
+                    if ((double)branchEnd[1] - dist * branchSlope > (double)topY) {
+                        branchStart[1] = topY;
+                    }
+                    else {
+                        branchStart[1] = (int)((double)branchEnd[1] - dist * branchSlope);
+                    }
+                    if(distToMat(branchStart, branchEnd) == -1) {
+                        foliageCoords[foliageCoordsIndex][0] = x;
+                        foliageCoords[foliageCoordsIndex][1] = yEnd;
+                        foliageCoords[foliageCoordsIndex][2] = z;
+                        foliageCoords[foliageCoordsIndex][3] = branchStart[1];
+                        foliageCoordsIndex++;
+                    }
+                }
+
+                yEnd--;
+                y--;
+            }
+        }
+        this.foliageCoords = new int[foliageCoordsIndex][4];
+        System.arraycopy(foliageCoords, 0, this.foliageCoords, 0, foliageCoordsIndex);
+    }
+
+    void crossSection(int x, int y, int z, float radius, int blockId)
+    {
+        int rad = (int)(radius + 0.618D);
+
+        int[] center = { x, y, z };
+        int[] coord = { 0, 0, 0 };
+
+        coord[1] = center[1];
+        for(int off1 = -rad; off1 <= rad; off1++)
+        {
+            coord[0] = center[0] + off1;
+
+            for(int off2 = -rad; off2 <= rad; off2++)
+            {
+                coord[2] = center[2] + off2;
+
+                double thisDist = Math.sqrt(Math.pow((double) Math.abs(off1) + 0.5D, 2D) + Math.pow((double) Math.abs(off2) + 0.5D, 2D));
+                if(thisDist <= (double)radius)
+                {
+                    int id = world.getBlockId(coord[0], coord[1], coord[2]);
+                    if (id == 0 || id == leavesID)
+                    {
+                        world.setBlockWithNotify(coord[0], coord[1], coord[2], blockId);
+                    }
+                }
+            }
+        }
+    }
+
+    float shapeFunc(int y)
+    {
+        if (y < height * 0.3D)
+        {
+            return -1.618F;
+        }
+        float radius = height / 2.0F;
+        float adj = height / 2.0F - y;
+        float dist;
+        if (adj == 0.0F) {
+            dist = radius;
+        } else if (Math.abs(adj) >= radius) {
+            dist = 0.0F;
+        } else {
+            dist = (float) Math.sqrt(Math.pow(Math.abs(radius), 2D) - Math.pow(Math.abs(adj), 2D));
+        }
+        dist *= 0.5F;
+        return dist;
+    }
+
+    float getFoliageShape(int y)
+    {
+        if(y < 0 || y >= foliageHeight)
+        {
+            return -1F;
+        }
+        else if (y == 0 || y == foliageHeight - 1)
+        {
+            return 2F;
+        }
+        else
+        {
+            return 3F;
+        }
+    }
+
+    void foliageCluster(int x, int y, int z)
+    {
+        for(int leavesY = y; leavesY < y + foliageHeight; leavesY++)
+        {
+            float radius = getFoliageShape(leavesY - y);
+            crossSection(x, leavesY, z, radius, leavesID);
+        }
+    }
+
+    void makeFoliage()
+    {
+        for (int[] foliageCoord : foliageCoords)
+        {
+            int x = foliageCoord[0];
+            int y = foliageCoord[1];
+            int z = foliageCoord[2];
+            foliageCluster(x, y, z);
+        }
+    }
+
+    void makeBranch(int[] startPos, int[] endPos, int blockId)
+    {
+        int[] dimensions = { 0, 0, 0 };
+        int dim0 = 0;
+
+        // Find widest dimension and assign it to dim0
+        for(int i = 0; i < 3; i++)
+        {
+            dimensions[i] = endPos[i] - startPos[i];
+            if(Math.abs(dimensions[i]) > Math.abs(dimensions[dim0]))
+            {
+                dim0 = i;
+            }
+        }
+
+        if(dimensions[dim0] == 0)
+        {
+            return;
+        }
+
+        // Look up other two dimensions
+        byte dim1 = axisConversionArray[dim0];
+        byte dim2 = axisConversionArray[dim0 + 3];
+
+        byte delta;
+        if(dimensions[dim0] > 0)
+        {
+            delta = 1;
+        }
+        else
+        {
+            delta = -1;
+        }
+
+        // Determine delta scale for other two dimensions
+        double dim1DeltaScale = (double)dimensions[dim1] / (double)dimensions[dim0];
+        double dim2DeltaScale = (double)dimensions[dim2] / (double)dimensions[dim0];
+
+        // Draw line from startPos to endPos
+        for(int i = 0; i != dimensions[dim0] + delta; i += delta)
+        {
+            int[] pos = { 0, 0, 0 };
+            pos[dim0] = MathHelper.floor((double)startPos[dim0] + (double)i + 0.5D);
+            pos[dim1] = MathHelper.floor((double)startPos[dim1] + (double)i * dim1DeltaScale + 0.5D);
+            pos[dim2] = MathHelper.floor((double)startPos[dim2] + (double)i * dim2DeltaScale + 0.5D);
+            world.setBlockWithNotify(pos[0], pos[1], pos[2], blockId);
+        }
+    }
+
+    boolean isHighEnoughToBranch(int i)
+    {
+        return (double)i >= (double) height * 0.2D;
+    }
+
+    void makeTrunk()
+    {
+        int x = origin[0];
+        int minY = origin[1];
+        int maxY = origin[1] + trunkHeight;
+        int z = origin[2];
+        int[] startPos = { x, minY, z };
+        int[] endPos = { x, maxY, z };
+        makeBranch(startPos, endPos, logID);
+        if(trunkWidth == 2)
+        {
+            startPos[0]++;
+            endPos[0]++;
+            makeBranch(startPos, endPos, logID);
+            startPos[2]++;
+            endPos[2]++;
+            makeBranch(startPos, endPos, logID);
+            startPos[0]--;
+            endPos[0]--;
+            makeBranch(startPos, endPos, logID);
+        }
+    }
+
+    void makeBranches()
+    {
+        int[] startPos = { origin[0], origin[1], origin[2] };
+        for (int[] branchPoint : foliageCoords)
+        {
+            int[] endPos = { branchPoint[0], branchPoint[1], branchPoint[2] };
+            startPos[1] = branchPoint[3];
+            int dy = startPos[1] - origin[1];
+            if (isHighEnoughToBranch(dy))
+            {
+                makeBranch(startPos, endPos, logID);
+            }
+        }
+    }
+
+    int distToMat(int[] startPos, int[] endPos)
+    {
+        int[] dimensions = { 0, 0, 0 };
+        int dim0 = 0;
+
+        // Find widest dimension and assign it to dim0
+        for(byte i = 0; i < 3; i++)
+        {
+            dimensions[i] = endPos[i] - startPos[i];
+            if(Math.abs(dimensions[i]) > Math.abs(dimensions[dim0]))
+            {
+                dim0 = i;
+            }
+        }
+
+        if(dimensions[dim0] == 0)
+        {
+            return -1;
+        }
+
+        // Look up other two dimensions
+        byte dim1 = axisConversionArray[dim0];
+        byte dim2 = axisConversionArray[dim0 + 3];
+
+        byte delta;
+        if(dimensions[dim0] > 0)
+        {
+            delta = 1;
+        }
+        else
+        {
+            delta = -1;
+        }
+
+        // Determine delta scale for other two dimensions
+        double dim1DeltaScale = (double)dimensions[dim1] / (double)dimensions[dim0];
+        double dim2DeltaScale = (double)dimensions[dim2] / (double)dimensions[dim0];
+
+        // Check all blocks from startPos to endPos, breaking if interrupted
+        int linePos = 0;
+        int lineLength = dimensions[dim0] + delta;
+        while (linePos != lineLength)
+        {
+            int[] pos = { 0, 0, 0 };
+            pos[dim0] = startPos[dim0] + linePos;
+            pos[dim1] = MathHelper.floor((double)startPos[dim1] + (double)linePos * dim1DeltaScale);
+            pos[dim2] = MathHelper.floor((double)startPos[dim2] + (double)linePos * dim2DeltaScale);
+            int idAtPos = world.getBlockId(pos[0], pos[1], pos[2]);
+            if(idAtPos != 0 && idAtPos != leavesID)
+            {
+                break;
+            }
+            linePos += delta;
+        }
+
+        // Check if was interrupted; if so, return the distance we travelled, otherwise return -1
+        if(linePos == lineLength)
+        {
+            return -1;
+        }
+        else
+        {
+            return Math.abs(linePos);
+        }
+    }
+
+    boolean canGenerateTree()
+    {
+        int[] bottomPos = { origin[0], origin[1], origin[2] };
+        int[] topPos = { origin[0], (origin[1] + height) - 1, origin[2] };
+        int blockIdUnderneath = world.getBlockId(origin[0], origin[1] - 1, origin[2]);
+        if(blockIdUnderneath != Blocks.COBBLE_NETHERRACK.id())
+        {
+            return false;
+        }
+        int interruptedTrunkHeight = distToMat(bottomPos, topPos);
+        if(interruptedTrunkHeight == -1)
+        {
+            return true;
+        }
+        if(interruptedTrunkHeight < 6)
+        {
+            return false;
+        }
+        else
+        {
+            height = interruptedTrunkHeight;
+            return true;
+        }
+    }
+
+    @Override
+	public void init(double d, double d1, double d2)
+    {
+        heightVariance = (int)(d * (12D + heightMod));
+        if(d > 0.5D)
+        {
+            foliageHeight = 5;
+        }
+        widthScale = d1;
+        foliageDensity = d2;
+    }
+
+    @Override
+	public boolean place(World world, Random random, int x, int y, int z)
+    {
+        this.world = world;
+        long seed = random.nextLong();
+        rnd.setSeed(seed);
+        while(world.getBlockId(x, y, z) == 0 && y > 0) { y--; }
+
+        origin[0] = x;
+        origin[1] = y + 1;
+        origin[2] = z;
+        if(height == 0)
+        {
+            height = 5 + rnd.nextInt(heightVariance);
+        }
+
+        if(canGenerateTree())
+        {
+            prepare();
+            makeFoliage();
+            makeTrunk();
+            makeBranches();
+            return true;
+        }
+        else
+        {
+            return false;
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/voxelizer/ConvexShapeVoxelizer.java b/game/core/src/main/java/net/minecraft/core/world/generate/voxelizer/ConvexShapeVoxelizer.java
new file mode 100644
index 000000000..c2e9ca9ef
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/voxelizer/ConvexShapeVoxelizer.java
@@ -0,0 +1,150 @@
+package net.minecraft.core.world.generate.voxelizer;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.*;
+
+import java.util.Objects;
+
+public class ConvexShapeVoxelizer implements Voxelizer {
+    public interface BlockFetcher {
+        /**
+         * Fetches the block to be placed at the given position.
+         * @param worldPos The real-world position of the block to be placed.
+         * @param replacing The block to be replaced.
+         * @param faceDistances Unsigned distances from each face in provided order, in world coordinates.
+         * @return The block to insert, or null to skip.
+         */
+        @Nullable Block<?> getBlock(final @NotNull TilePosc worldPos, final @NotNull Block<?> replacing, final float @NotNull [] faceDistances);
+    }
+
+    private final @NotNull Vector3f @NotNull [] @NotNull [] faces;
+    private final @NotNull BlockFetcher fetcher;
+
+    public ConvexShapeVoxelizer(
+        final @NotNull Vector3f @NotNull [] points,
+        final int @NotNull [] @NotNull [] faces,
+        final @NotNull Matrix4f transformation,
+        final @NotNull BlockFetcher fetcher
+    ) {
+        this.fetcher = fetcher;
+
+        final @NotNull Vector3f @NotNull [] tPoints = new Vector3f[points.length];
+        for (int i = 0; i < points.length; i++) {
+            tPoints[i] = Objects.requireNonNull(new Vector4f(points[i], 1.0f).mul(transformation).xyz(new Vector3f()));
+        }
+
+        this.faces = new Vector3f[faces.length][];
+        for (int i = 0; i < faces.length; i++) {
+            this.faces[i] = new Vector3f[faces[i].length];
+
+            for (int j = 0; j < faces[i].length; j++) {
+                this.faces[i][j] = tPoints[faces[i][j]];
+            }
+        }
+    }
+
+    @Override
+    public void voxelize(final @NotNull World world, final @NotNull TilePosc origin) {
+        this.fillConvexSolid(world, origin, this.fetcher, this.faces);
+    }
+
+    private void fillConvexSolid(
+        final @NotNull World world,
+        final @NotNull TilePosc origin,
+        final @NotNull BlockFetcher fetcher,
+        final @NotNull Vector3f @NotNull [] @NotNull [] faces
+    ) {
+        // Compute planes for all faces
+        final @NotNull Plane @NotNull [] planes = new Plane[faces.length];
+        for (int i = 0; i < faces.length; i++) {
+            final @NotNull var f = faces[i];
+            planes[i] = new Plane(f[0], f[1], f[2]);
+        }
+
+        final @NotNull Vector3f min = new Vector3f(Float.POSITIVE_INFINITY);
+        final @NotNull Vector3f max = new Vector3f(Float.NEGATIVE_INFINITY);
+        for (final @NotNull var f : faces) {
+            for (final @NotNull var v : f) {
+                min.min(v);
+                max.max(v);
+            }
+        }
+
+        // Compute centroid to orient planes consistently
+        final @NotNull Vector3f centroid = new Vector3f();
+        int count = 0;
+        for (final @NotNull var f : faces) {
+            for (final @NotNull var v : f) {
+                centroid.add(v);
+                count++;
+            }
+        }
+        centroid.div(count);
+
+        // Flip planes so centroid is on inside side
+        for (final @NotNull var p : planes) {
+            if (p.signedDistance(centroid) > 0f) {
+                p.flip();
+            }
+        }
+
+        // Rasterize AABB with inside-plane tests
+        final @NotNull Vector3f p = new Vector3f();
+        final @NotNull TilePos ti = new TilePos();
+        final @NotNull TilePos temp = new TilePos();
+        final float @NotNull [] planeDistances = new float[planes.length];
+        for (ti.x = MathHelper.floor(min.x); ti.x <= MathHelper.floor(max.x); ti.x++) {
+            for (ti.y = MathHelper.floor(min.y); ti.y <= MathHelper.floor(max.y); ti.y++) {
+                for (ti.z = MathHelper.floor(min.z); ti.z <= MathHelper.floor(max.z); ti.z++) {
+                    p.set(ti.x + 0.5f, ti.y + 0.5f, ti.z + 0.5f);
+
+                    boolean inside = true;
+                    for (int i = 0; i < planes.length; i++) {
+                        planeDistances[i] = -planes[i].signedDistance(p);
+                        if (planeDistances[i] < 0.0f) {
+                            inside = false;
+                            break;
+                        }
+                    }
+
+                    if (inside) {
+                        ti.add(origin.x(), origin.y(), origin.z(), temp);
+                        final @NotNull Block<?> replacing = world.getBlockType(temp);
+                        final @Nullable Block<?> replacer = fetcher.getBlock(temp, replacing, planeDistances);
+
+                        if (replacer != null) {
+                            world.setBlockTypeNotify(temp, replacer);
+                        }
+                    }
+                }
+            }
+        }
+    }
+
+    private static class Plane {
+        final @NotNull Vector3f normal;
+        float d;
+
+        Plane(final @NotNull Vector3f a, final @NotNull Vector3f b, final @NotNull Vector3f c) {
+            final @NotNull Vector3f ab = Objects.requireNonNull(new Vector3f(b).sub(a));
+            final @NotNull Vector3f ac = Objects.requireNonNull(new Vector3f(c).sub(a));
+            this.normal = Objects.requireNonNull(Objects.requireNonNull(ab.cross(ac)).normalize());
+            this.d = -this.normal.dot(a);
+        }
+
+        float signedDistance(final @NotNull Vector3f p) {
+            return this.normal.dot(p) + this.d;
+        }
+
+        void flip() {
+            this.normal.negate();
+            this.d = -this.d;
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/voxelizer/Voxelizer.java b/game/core/src/main/java/net/minecraft/core/world/generate/voxelizer/Voxelizer.java
new file mode 100644
index 000000000..6ad5f8950
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/voxelizer/Voxelizer.java
@@ -0,0 +1,9 @@
+package net.minecraft.core.world.generate.voxelizer;
+
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+
+public interface Voxelizer {
+    void voxelize(final @NotNull World world, final @NotNull TilePosc origin);
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/WorleyNoise.java b/game/core/src/main/java/net/minecraft/core/world/noise/WorleyNoise.java
index 08be1ac72..06e492ca3 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/WorleyNoise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/WorleyNoise.java
@@ -41,6 +41,10 @@ public class WorleyNoise
     public static class Result {
         public double distance;
         public int index;
+
+        public @NotNull Random getRandom() {
+            return new Random(index);
+        }
     }
 
     private static final @NotNull Vector2dc RANGE = new Vector2d(0.5, 1.0);
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java b/game/core/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
index 3ef04360f..274d9ef36 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
@@ -27,7 +27,7 @@ public class WorldTypeNether
 
     private static float[] getLightRamp() {
         float[] brightnessRamp = new float[32];
-        float f = 0.15F;
+        float f = 0.35F;
         for (int i = 0; i <= 15; i++) {
             float f1 = 1.0F - (float) i / 15F;
             brightnessRamp[i] = ((1.0F - f1) / (f1 * 3F + 1.0F)) * (1.0F - f) + f;
diff --git a/game/core/src/main/resources/lang/en_US/biomes.lang b/game/core/src/main/resources/lang/en_US/biomes.lang
index c32253e38..c63d7b317 100644
--- a/game/core/src/main/resources/lang/en_US/biomes.lang
+++ b/game/core/src/main/resources/lang/en_US/biomes.lang
@@ -21,12 +21,13 @@ biome.overworld.swampland.muddy=Muddy Swamp
 biome.overworld.outback.grassy=Grassy Outback
 biome.overworld.caatinga=Caatinga
 biome.overworld.caatinga.plains=Caatinga Plains
-biome.nether.nether=Nether
+biome.nether.crag=The Crag
+biome.nether.old_world=The Old World
 biome.nether.volcanic_islands=Volcanic Islands
 biome.nether.sulfur_pools=Sulfur Pools
 biome.nether.crystal_forest=Crystal Forest
-biome.nether.ash_plains=Ash Plains
-biome.nether.boneyard=Boneyard
+biome.nether.crystal_field=Crystal Field
+biome.nether.shelf=The Shelf
 biome.drift.drift=Drift
 
 biome.overworld.legacy.tundra=Beta Tundra
diff --git a/game/core/src/main/resources/lang/en_US/item.lang b/game/core/src/main/resources/lang/en_US/item.lang
index e27a281a7..5b98af2c2 100644
--- a/game/core/src/main/resources/lang/en_US/item.lang
+++ b/game/core/src/main/resources/lang/en_US/item.lang
@@ -490,3 +490,11 @@ item.statue.pigman.desc=An ancient marble statue found in a long-forgotten place
 
 item.dough.name=Dough
 item.dough.desc=Uncooked dough. Can be baked into bread.
+
+item.rubyglass.crystal.cracked.name=Cracked Rubyglass Crystal
+item.rubyglass.crystal.cracked.desc=Cracked open and full of impurities. Must planted in Netherrack to purify.
+item.rubyglass.crystal.pure.name=Rubyglass Crystal
+item.rubyglass.crystal.pure.desc=A shard of sanguine crystal, perfectly intact and slightly translucent.
+
+item.sulfur.name=Sulfur
+item.sulfur.desc=Highly flammable and yellow. Packs a punch.
\ No newline at end of file
diff --git a/game/core/src/main/resources/lang/en_US/tile.lang b/game/core/src/main/resources/lang/en_US/tile.lang
index 37c497bc0..99b9945ec 100644
--- a/game/core/src/main/resources/lang/en_US/tile.lang
+++ b/game/core/src/main/resources/lang/en_US/tile.lang
@@ -461,13 +461,15 @@ tile.sand.name=Sand
 tile.sand.desc=Gets everywhere.
 tile.gravel.name=Gravel
 tile.gravel.desc=A loose collection of pebbles.
-tile.sulfur.name=Sulfur
-tile.sulfur.desc=Yellow.
+tile.brimsand.name=Brimsand
+tile.brimsand.desc=Scorched sulfuric sand rich in gunpowder.
 
 tile.bedrock.name=Bedrock
 tile.bedrock.desc=The toughest substance known to man.
-tile.boneshale.name=Bone Shale
+tile.boneshale.name=Boneshale
 tile.boneshale.desc=An incredibly tough white rock torn from the deepest depths.
+tile.boneshale.cobbled.name=Fractured Boneshale
+tile.boneshale.cobbled.desc=Cobbles of boneshale brought to the surface by intense tectonic activity.
 
 tile.fluid.water.flowing.name=Flowing Water
 tile.fluid.water.flowing.desc=Water that flows when placed.
@@ -1033,10 +1035,10 @@ tile.pumpkin.redstone.desc=An orange squash with a spooky face, lit by a redston
 
 tile.cobble.netherrack.name=Cobbled Netherrack
 tile.cobble.netherrack.desc=Dark red rock that burns forever.
-tile.cobble.netherrack.igneous.name=Igneous Cobbled Netherrack
-tile.cobble.netherrack.igneous.desc=Extreme heat has made this rock glow from inside.
-tile.cobble.netherrack.mossy.name=Mossy Cobbled Netherrack
-tile.cobble.netherrack.mossy.desc=Cobbled netherrack, covered in something like moss.
+tile.magma.name=Magma
+tile.magma.desc=Lava that's been partially cooled. Melts in extreme heat.
+tile.cobble.netherrack.crystalline.name=Crystalline Netherrack
+tile.cobble.netherrack.crystalline.desc=Netherrack, covered in a web of Rubyglass.
 tile.netherrack.name=Netherrack
 tile.netherrack.desc=Dark red rock, smoothed by heat and time.
 tile.brick.netherrack.name=Netherrack Bricks
@@ -1053,7 +1055,7 @@ tile.stairs.brick.netherrack.name=Netherrack Brick Stairs
 tile.stairs.brick.netherrack.desc=Netherrack brick block used for rapid vertical movement.
 
 tile.soulsand.name=Soul Sand
-tile.soulsand.desc=Squishy brown sand that's tough to walk through.
+tile.soulsand.desc=Finely grained ancient bones. The weight of their sins slows you down.
 tile.soulschist.name=Soul Schist
 tile.soulschist.desc=A hideous medley of ancient bones, fused through heat, pressure, and time.
 
@@ -1380,14 +1382,24 @@ tile.glass.steel.desc=Like glass, but without the fragility.
 tile.rope.name=Rope
 tile.rope.desc=Rope, rope, rope your boat.
 
-tile.crystal.name=Nether Crystal
-tile.crystal.desc=A bright, iridescent stone that grows under intense heat.
+tile.rubyglass.name=Block of Rubyglass
+tile.rubyglass.desc=A bright, iridescent crystal brimming with energy.
+tile.rubyglass.pure.name=Block of Pure Rubyglass
+tile.rubyglass.pure.desc=A bright, iridescent crystal brimming with energy. Contains fewer impurities than normal rubyglass.
 
-tile.crystal.stalk.name=Nether Crystal Stalk
-tile.crystal.stalk.desc=A stalk of crystal, branching out in many directions.
+tile.rubyglass.growth.name=Rubyglass Sprout
+tile.rubyglass.growth.desc=A small sprout of rubyglass, branching out in many directions.
 
-tile.netherrack.crystalline.name=Crystalline Netherrack
-tile.netherrack.crystalline.desc=Cobbled Netherrack, embedded with crystals.
+tile.rubyglass.circuit.name=Rubyglass Circuit
+tile.rubyglass.circuit.desc=Netherrack etched with lines of rubyglass. It resonates with latent power.
+
+tile.vent.name=Chimney
+tile.vent.desc=A rocky column that emits a stream of smoke.
+
+tile.bone_pile.name=Bone Pile
+tile.bone_pile.desc=A pile of solid calcium.
+tile.soul_catcher.name=Soul Catcher
+tile.soul_catcher.desc=Tendrils of soul sand that seemingly move on their own. Hard to walk through.
 
 tile.jar.butterfly.blue.name=Blue Butterfly Jar
 tile.jar.butterfly.blue.desc=A glass jar containing a blue butterfly.
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/SmeltingGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/SmeltingGenerator.java
index 4dc285a22..22cb2c065 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/SmeltingGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/SmeltingGenerator.java
@@ -46,7 +46,7 @@ public class SmeltingGenerator {
         blastRecipe("cobble_stone_to_slate", Blocks.COBBLE_STONE.getDefaultStack(), Blocks.SLATE.getDefaultStack());
         blastRecipe("iron_ingot_and_coal_to_crude_steel", Items.INGOT_IRON.getDefaultStack(), Items.COAL.getDefaultStack(), Items.INGOT_STEEL_CRUDE.getDefaultStack());
         blastRecipe("iron_ingot_and_charcoal_to_crude_steel", Items.INGOT_IRON.getDefaultStack(), new ItemStack(Items.COAL, 1, 1), Items.INGOT_STEEL_CRUDE.getDefaultStack());
-        blastRecipe("cobble_netherrack_to_igneous_netherrack", Blocks.COBBLE_NETHERRACK.getDefaultStack(), Blocks.COBBLE_NETHERRACK_IGNEOUS.getDefaultStack());
+        blastRecipe("cobble_netherrack_to_magma", Blocks.COBBLE_NETHERRACK.getDefaultStack(), Blocks.MAGMA.getDefaultStack());
     }
 
     private static void furnaceRecipe(String id, ItemStack input, ItemStack output) {
